package com.xypower.common;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

public class ZipUtils {
    public static void ZipFolder(File srcFile, File zipFile) {
        try {
            ZipOutputStream outZip = new ZipOutputStream(new FileOutputStream(zipFile));
            ZipFiles(srcFile.getParent() + File.separator, srcFile.getName(), outZip);
            outZip.finish();
            outZip.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static void ZipFiles(String srcFileParentName, String srcFileName, ZipOutputStream zipOutputSteam) throws Exception {
        if (zipOutputSteam == null)
            return;
        File file = new File(srcFileParentName + srcFileName);

        if (file.isFile()) {
            ZipEntry zipEntry = new ZipEntry(srcFileName);
            FileInputStream inputStream = new FileInputStream(file);
            zipOutputSteam.putNextEntry(zipEntry);
            int len;
            byte[] buffer = new byte[1024 * 256];
            while ((len = inputStream.read(buffer)) != -1) {
                zipOutputSteam.write(buffer, 0, len);
            }
            zipOutputSteam.closeEntry();
        } else {
            // folder
            String fileList[] = file.list();
            // NO sub file
            if (fileList.length <= 0) {
                ZipEntry zipEntry = new ZipEntry(srcFileName + File.separator);
                zipOutputSteam.putNextEntry(zipEntry);
                zipOutputSteam.closeEntry();
            }
            //
            for (int i = 0; i < fileList.length; i++) {
                ZipFiles(srcFileParentName + srcFileName + "/", fileList[i], zipOutputSteam);
            }
        }
    }

}
